<!--
/*
 * Copyright 2019 Gregg Tavares
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
-->
<style>
    body {
        background: #444;
        color: white;
        font-family: monospace;
    }
    #gamepads>* {
        background: #333;
        padding: 1em;
        margin: 10px 5px 0 0;
    }
    #gamepads pre {
        white-space: pre-wrap;
    }
    
    .head {
      display: flex;
    }
    .head .id {
      flex: 1 1 auto;
    }
    .head .index,
    .head .id {
      display: inline-block;
      background: #222;
      padding: 0.5em;
    }
    .head .index {
    }
    
    .info .label {
      width: 7em;
      display: inline-block;
    }
    .info>div {
      padding: 0.25em;
      background: #222;
      margin: 0.25em 0.25em 0 0;
    }
    
    .inputs {
      display: flex;
    }
    .axes {
      display: flex;
      align-items: flex-start;
    }
    
    .svg text {
      color: #CCC;
      font-family: monospace;
    }
    
    .axes svg text {
      font-size: 0.6px;
    }
    .buttons svg text {
      font-size: 1.2px;
    }
    .axes>div, .buttons>div {
      display: inline-block;
      background: #222;
    }
    .axes>div {
      margin: 2px 5px 0 0;
    }
    .buttons>div {
      margin: 2px 2px 0 0;
    }
    </style>
    <body>
    
    <h1>HTML5 Gamepad Test</h1>
    <div>running: <span id="running"></span></div>
    <div id="gamepads"></div>
    </body>
    <script>
    
    const fudgeFactor = 2;  // because of bug in Chrome related to svg text alignment font sizes can not be < 1
    const runningElem = document.querySelector('#running');
    const gamepadsElem = document.querySelector('#gamepads');
    const gamepadsByIndex = {};
    
    const controllerTemplate = `
    <div>
      <div class="head"><div class="index"></div><div class="id"></div></div>
      <div class="info"><div class="label">connected:</div><span class="connected"></span></div>
      <div class="info"><div class="label">mapping:</div><span class="mapping"></span></div>
      <div class="inputs">
        <div class="axes"></div>
        <div class="buttons"></div>
      </div>
    </div>
    `;
    const axisTemplate = `
    <svg viewBox="-2.2 -2.2 4.4 4.4" width="128" height="128">
        <circle cx="0" cy="0" r="2" fill="none" stroke="#888" stroke-width="0.04" />
        <path d="M0,-2L0,2M-2,0L2,0" stroke="#888" stroke-width="0.04" />
        <circle cx="0" cy="0" r="0.22" fill="red" class="axis" />
        <text text-anchor="middle" fill="#CCC" x="0" y="2">0</text>
    </svg>
    `
    
    const buttonTemplate = `
    <svg viewBox="-2.2 -2.2 4.4 4.4" width="64" height="64">
      <circle cx="0" cy="0" r="2" fill="none" stroke="#888" stroke-width="0.1" />
      <circle cx="0" cy="0" r="0" fill="none" fill="red" class="button" />
      <text class="value" dominant-baseline="middle" text-anchor="middle" fill="#CCC" x="0" y="0">0.00</text>
      <text class="index" alignment-baseline="hanging" dominant-baseline="hanging" text-anchor="start" fill="#CCC" x="-2" y="-2">0</text>
    </svg>
    `;
    
    function addGamepad(gamepad) {
      console.log('add:', gamepad.index);
      const elem = document.createElement('div');
      elem.innerHTML = controllerTemplate;
    
      const axesElem = elem.querySelector('.axes');
      const buttonsElem = elem.querySelector('.buttons');
      
      const axes = [];
      for (let ndx = 0; ndx < gamepad.axes.length; ndx += 2) {
        const div = document.createElement('div');
        div.innerHTML = axisTemplate;
        axesElem.appendChild(div);
        axes.push({
          axis: div.querySelector('.axis'),
          value: div.querySelector('text'),
        });
      }
    
      const buttons = [];
      for (let ndx = 0; ndx < gamepad.buttons.length; ++ndx) {
        const div = document.createElement('div');
        div.innerHTML = buttonTemplate;
        buttonsElem.appendChild(div);
        div.querySelector('.index').textContent = ndx;
        buttons.push({
          circle: div.querySelector('.button'),
          value: div.querySelector('.value'),
        });
      }
    
      gamepadsByIndex[gamepad.index] = {
        gamepad,
        elem,
        axes,
        buttons,
        index: elem.querySelector('.index'),
        id: elem.querySelector('.id'),
        mapping: elem.querySelector('.mapping'),
        connected: elem.querySelector('.connected'),
      };
      gamepadsElem.appendChild(elem);
    }
    
    function removeGamepad(gamepad) {
      const info = gamepadsByIndex[gamepad.index];
      if (info) {
        delete gamepadsByIndex[gamepad.index];
        info.elem.parentElement.removeChild(info.elem);
      }
    }
    
    function addGamepadIfNew(gamepad) {
      const info = gamepadsByIndex[gamepad.index];
      if (!info) {
        addGamepad(gamepad);
      } else {
        // This broke sometime in the past. It used to be
        // the same gamepad object was returned forever.
        // Then Chrome only changed to a new gamepad object
        // is returned every frame.
        info.gamepad = gamepad;
      }
    }
    
    function handleConnect(e) {
      console.log('connect');
      addGamepadIfNew(e.gamepad);
    }
    
    function handleDisconnect(e) {
      console.log('disconnect');
      removeGamepad(e.gamepad);
    }
    
    const t = String.fromCharCode(0x26AA);
    const f = String.fromCharCode(0x26AB);
    function onOff(v) {
      return v ? t : f;
    }
    
    const keys = ['index', 'id', 'connected', 'mapping', /*'timestamp'*/];
    function processController(info) {
      const {elem, gamepad, axes, buttons} = info;
      const lines = [`gamepad  : ${gamepad.index}`];
      for (const key of keys) {
        info[key].textContent = gamepad[key];
      }
      axes.forEach(({axis, value}, ndx) => {
        const off = ndx * 2;
        axis.setAttributeNS(null, 'cx', gamepad.axes[off    ] * fudgeFactor);
        axis.setAttributeNS(null, 'cy', gamepad.axes[off + 1] * fudgeFactor);
        value.textContent = `${gamepad.axes[off].toFixed(2).padStart(5)},${gamepad.axes[off + 1].toFixed(2).padStart(5)}`;
      });
      buttons.forEach(({circle, value}, ndx) => {
        const button = gamepad.buttons[ndx];
        circle.setAttributeNS(null, 'r', button.value * fudgeFactor);
        circle.setAttributeNS(null, 'fill', button.pressed ? 'red' : 'gray');
        value.textContent = `${button.value.toFixed(2)}`;
      });
      
    //  lines.push(`axes     : [${gamepad.axes.map((v, ndx) => `${ndx}: ${v.toFixed(2).padStart(5)}`).join(', ')} ]`);
    //  lines.push(`buttons  : [${gamepad.buttons.map((v, ndx) => `${ndx}: ${onOff(v.pressed)} ${v.value.toFixed(2)}`).join(', ')} ]`);
     // elem.textContent = lines.join('\n');
    }
    
    function addNewPads() {
      const gamepads = navigator.getGamepads();
      for (let i = 0; i < gamepads.length; i++) {
        const gamepad = gamepads[i]
        if (gamepad) {
          addGamepadIfNew(gamepad);
        }
      }
    }
    
    window.addEventListener("gamepadconnected", handleConnect);
    window.addEventListener("gamepaddisconnected", handleDisconnect);
    
  

    var ws = new WebSocket("ws://" + location.host .split(':')[0] + ":8082");

    ws.onopen = function() {
                  
    // Web Socket is connected, send data using send()
     ws.send("Message to send");
      // alert("Message is sent...");
    };

    ws.onmessage = function (evt) { 
      var received_msg = evt.data;
      alert("Message is received...");
    };

    ws.onclose = function() { 
      
      // websocket is closed.
      // alert("Connection is closed..."); 
    };
    
    function process() {
      runningElem.textContent = ((performance.now() * 0.001 * 60 | 0) % 100).toString().padStart(2, '0');
      addNewPads();  // some browsers add by polling, others by event
    
      const gamepads = navigator.getGamepads();
      if(gamepads[0])
      {
        const gamepadState = {
          id: gamepads[0].id,
          axis: [
            gamepads[0].axes[0].toFixed(2),
            gamepads[0].axes[1].toFixed(2),
            gamepads[0].axes[2].toFixed(2),
            gamepads[0].axes[3].toFixed(2),
          ],
          buttons_value: [
            gamepads[0].buttons[0].value.toFixed(2),
            gamepads[0].buttons[1].value.toFixed(2),
            gamepads[0].buttons[2].value.toFixed(2),
            gamepads[0].buttons[3].value.toFixed(2),
            gamepads[0].buttons[4].value.toFixed(2),
            gamepads[0].buttons[5].value.toFixed(2),
            gamepads[0].buttons[6].value.toFixed(2),
            gamepads[0].buttons[7].value.toFixed(2),
            gamepads[0].buttons[8].value.toFixed(2),
            gamepads[0].buttons[9].value.toFixed(2),
            gamepads[0].buttons[10].value.toFixed(2),
            gamepads[0].buttons[11].value.toFixed(2),
            gamepads[0].buttons[12].value.toFixed(2),
            gamepads[0].buttons[13].value.toFixed(2),
            gamepads[0].buttons[14].value.toFixed(2),
            gamepads[0].buttons[15].value.toFixed(2),
            gamepads[0].buttons[16].value.toFixed(2),
          ],
          buttons_pressed: [
            gamepads[0].buttons[0].pressed,
            gamepads[0].buttons[1].pressed,
            gamepads[0].buttons[2].pressed,
            gamepads[0].buttons[3].pressed,
            gamepads[0].buttons[4].pressed,
            gamepads[0].buttons[5].pressed,
            gamepads[0].buttons[6].pressed,
            gamepads[0].buttons[7].pressed,
            gamepads[0].buttons[8].pressed,
            gamepads[0].buttons[9].pressed,
            gamepads[0].buttons[10].pressed,
            gamepads[0].buttons[11].pressed,
            gamepads[0].buttons[12].pressed,
            gamepads[0].buttons[13].pressed,
            gamepads[0].buttons[14].pressed,
            gamepads[0].buttons[15].pressed,
            gamepads[0].buttons[16].pressed,
          ],
        }
        
        ws.send(JSON.stringify(gamepadState))
      }

      Object.values(gamepadsByIndex).forEach(processController);
      requestAnimationFrame(process);
    }
    requestAnimationFrame(process);
    </script>
    